#!/bin/sh

DUMP_FILE="/opt/backup/fulldb.dump"
MYSQL_OPT="-u root"
CHECK_MYSQL="mysqladmin -u root status"
LOGFILE="/opt/backup/log/Backup.log"

logw() {
	if [ "$1" = "END" ]; then
		echo "**********  End Backup  **********" >>$LOGFILE
	else
		echo "$1" >>$LOGFILE
	fi
}

start_slave() {
	mysql $MYSQL_OPT -e 'START SLAVE SQL_THREAD;' >/dev/null 2>>$LOGFILE ||
		{ logw "Error \"START SLAVE SQL_THREAD\""; logw "END"; exit 1; }
}

echo "********** Start Backup **********" >$LOGFILE

# MySQLғmF
${CHECK_MYSQL} >/dev/null 2>>$LOGFILE ||
	{ logw "MySQL is not running"; logw "END"; exit 1; }

# SQLXbhғmF
CHECK_SLAVE=`mysql -u root -e 'SHOW SLAVE STATUS\G' |
             grep 'Slave_SQL_Running:' |
             sed -e 's/[[:space:]]\{1,\}//g' | cut -d':' -f2`
[ $CHECK_SLAVE = "Yes" ] || { logw "Slave_SQL Stopped!"; logw "END"; exit 1; }

# SQLXbh̒~
mysql $MYSQL_OPT -e 'STOP SLAVE SQL_THREAD;' >/dev/null 2>>$LOGFILE ||
	{ logw "Error \"STOP SLAVE SQL_THREAD\""; logw "END"; exit 1; }

# e[ũN[Y
mysql $MYSQL_OPT -e 'FLUSH TABLES;' >/dev/null 2>>$LOGFILE ||
	{ logw "Error \"FLUSH TABLES\""; start_slave; logw "END"; exit 1; }

# obNAbv
(mysqldump $MYSQL_OPT --all-databases > $DUMP_FILE) >/dev/null 2>>$LOGFILE ||
	{ logw "Error \"mysqldump\""; start_slave; logw "END"; exit 1; }

# SQLXbh̊Jn
start_slave

logw "END"

